Skip to main content
`Ctrl`+`K`

# Source code for silx.utils.enum

    # /*##########################################################################
    #
    # Copyright (c) 2019 European Synchrotron Radiation Facility
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in
    # all copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
    # THE SOFTWARE.
    #
    # ###########################################################################*/
    """An :class:`.Enum` class with additional features."""

    __authors__ = ["T. Vincent"]
    __license__ = "MIT"
    __date__ = "29/04/2019"

    from silx.utils.deprecation import deprecated
    import enum

    class Enum(enum.Enum):
        """Enum with additional class methods."""

        @classmethod
        @deprecated(since_version="2.1.1", replacement="Enum(value)")
        def from_value(cls, value):
            """Convert a value to corresponding Enum member

            :param value: The value to compare to Enum members
               If it is already a member of Enum, it is returned directly.
            :return: The corresponding enum member
            :rtype: Enum
            :raise ValueError: In case the conversion is not possible
            """
            if isinstance(value, cls):
                return value
            for member in cls:
                if value == member.value:
                    return member
            raise ValueError("Cannot convert: %s" % value)

        @classmethod
        def members(cls):
            """Returns a tuple of all members.

            :rtype: Tuple[Enum]
            """
            return tuple(member for member in cls)

        @classmethod
        def names(cls):
            """Returns a tuple of all member names.

            :rtype: Tuple[str]
            """
            return tuple(member.name for member in cls)

        @classmethod
        def values(cls):
            """Returns a tuple of all member values.

            :rtype: Tuple
            """
            return tuple(member.value for member in cls)